#define SwapDword(data) (*((BYTE*)(data) + 0) << 24 | *((BYTE*)(data) + 1) << 16 | *((BYTE*)(data) + 2) << 8 | *((BYTE*)(data) + 3))
#define SwapWord(data) (*((BYTE*)(data) + 0) << 8 | *((BYTE*)(data) + 1))

//#define LEtoBE(data) ((((data) >> 24) & 0xFF) | ((((data) >> 16) & 0xFF) << 8) | ((((data) >> 8) & 0xFF) << 16) | (((data) & 0xFF) << 24))
#define StoreBEDword(d, s)\
{\
 *((BYTE*)(d)+0) = (BYTE)(((s)>>24)&0xFF);\
 *((BYTE*)(d)+1) = (BYTE)(((s)>>16)&0xFF);\
 *((BYTE*)(d)+2) = (BYTE)(((s)>>8)&0xFF);\
 *((BYTE*)(d)+3) = (BYTE)((s)&0xFF);\
}
#define StoreBEWord(d, s)\
{\
 *((BYTE*)(d)+0) = (BYTE)(((s)>>8)&0xFF);\
 *((BYTE*)(d)+1) = (BYTE)((s)&0xFF);\
}

#define COMPARE4(d, s) ((d)[0] != (s)[0] || (d)[1] != (s)[1] || (d)[2] != (s)[2] || (d)[3] != (s)[3])

typedef struct
{
	BYTE* data;
	DWORD size;
}CHUNK;

typedef struct _tag_EVENTLIST
{
	DWORD duration;
	DWORD time;

	BYTE status;
	UINT param1;	// note/control no.
	UINT param2;	// velo/gtime/control val.
	UINT param3;	// gtime

	BYTE* data;		// for exclusive
	DWORD size;

	struct _tag_EVENTLIST* next;
}EVENT;

typedef struct
{
	BYTE* data;
	DWORD size;

	EVENT* start;
	EVENT* stop;

	EVENT* events;
	DWORD dbase;
	DWORD gbase;

	TCHAR name[MAX_PATH];
}SMAF;

//findchunk͓̂낤
BOOL findchunk4(BYTE* data, DWORD dsize, char* cname, CHUNK* ch);
BOOL findchunk3(BYTE* data, DWORD dsize, char* cname, CHUNK* ch);
DWORD GetVValAndForward(BYTE** pdata);
DWORD GetVValSize(BYTE* pdata);
DWORD GetVValAndForward4HPS(BYTE** pdata);
DWORD GetVVal(BYTE* pdata);
void ClearEvents(SMAF* smaf);
SMAF* DeleteEvent(SMAF* smaf, EVENT* e);
void InsertEvent(SMAF* smaf, EVENT* e);
void ConvertEvents2(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup, DWORD start, DWORD stop, UINT chshift);
void ConvertEvents(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup, DWORD start, DWORD stop);
SMAF* FreeSmaf(SMAF* smaf);
BOOL ReloadSmaf(SMAF* smaf);
SMAF* CreateSmaf(UINT dbase, UINT gbase);
SMAF* LoadSmaf(LPCTSTR fname);
BYTE* CompileSmaf(SMAF* smaf, DWORD* datasize);
